Pertanyaan meluncurkan Watir-Webdriver dalam aksi rel


Saya perlu mendapatkan data dari halaman yang secara dinamis membangun, solusi yang saya temukan adalah Watir.

Kode berikutnya berfungsi dengan baik dari irb:

require 'rubygems'
require 'watir-webdriver'
require 'headless'

Headless.ly do
  browser = Watir::Browser.new :firefox
  browser.goto "google.com"
  browser.close
end

jika saya mencoba untuk menjalankannya dari aplikasi rel memiliki masalah berikutnya:

gemfile:

gem 'headless'
gem 'watir-webdriver'

tindakan:

def test_action
    Headless.ly do
          browser = Watir::Browser.new(:firefox)
          browser.goto "google.com"
          browser.close
     end
end

memiliki keluaran berikutnya:

no such file to load -- {
  "frozen": {
    "app.update.auto": false,
    "app.update.enabled": false,
    "browser.download.manager.showWhenStarting": false,
    "browser.EULA.override": true,
    "browser.EULA.3.accepted": true,
    "browser.link.open_external": 2,
    "browser.link.open_newwindow": 2,
    "browser.offline": false,
    "browser.safebrowsing.enabled": false,
    "browser.safebrowsing.malware.enabled": false,
    "browser.search.update": false,
    "browser.sessionstore.resume_from_crash": false,
    "browser.shell.checkDefaultBrowser": false,
    "browser.tabs.warnOnClose": false,
    "browser.tabs.warnOnOpen": false,
    "devtools.errorconsole.enabled": true,
    "dom.disable_open_during_load": false,
    "extensions.autoDisableScopes": 10,
    "extensions.logging.enabled": true,
    "extensions.update.enabled": false,
    "extensions.update.notifyUser": false,
    "network.manage-offline-status": false,
    "network.http.phishy-userpass-length": 255,
    "offline-apps.allow_by_default": true,
    "prompts.tab_modal.enabled": false,
    "security.fileuri.origin_policy": 3,
    "security.fileuri.strict_origin_policy": false,
    "security.warn_entering_secure": false,
    "security.warn_entering_secure.show_once": false,
    "security.warn_entering_weak": false,
    "security.warn_entering_weak.show_once": false,
    "security.warn_leaving_secure": false,
    "security.warn_leaving_secure.show_once": false,
    "security.warn_submit_insecure": false,
    "security.warn_viewing_mixed": false,
    "security.warn_viewing_mixed.show_once": false,
    "signon.rememberSignons": false,
    "toolkit.networkmanager.disable": true,
    "toolkit.telemetry.prompted": 2,
    "toolkit.telemetry.enabled": false,
    "toolkit.telemetry.rejected": true
  },
  "mutable": {
    "browser.dom.window.dump.enabled": true,
    "browser.startup.page": 0,
    "browser.startup.homepage": "about:blank",
    "dom.max_script_run_time": 30,
    "dom.report_all_js_exceptions": true,
    "javascript.options.showInConsole": true,
    "network.http.max-connections-per-server": 10,
    "webdriver_accept_untrusted_certs": true,
    "webdriver_assume_untrusted_issuer": true
  }
}

dimana masalah?


4
2018-04-21 16:51


asal


Jawaban:


Proyek saya memiliki kesalahan yang sama dengan Anda

Saya menemukan pertanyaan ini disebabkan oleh permata "selenium-webdriver"

dan verisinya harus '2.20.0'

Jika versi gem Anda lebih tinggi dari ini, kesalahan ini akan terjadi


2
2018-04-24 14:55



masukkan kode ini di direktori initializers Anda, bekerja dengan 'watir-webdriver', '0,5.5'

require 'childprocess'
require 'tmpdir'
require 'fileutils'
require 'date'

require 'multi_json'
require 'selenium/webdriver/common'

module Selenium
  module WebDriver

    if MultiJson.respond_to?(:load)
      # @api private
      def self.json_load(obj)
        MultiJson.decode(obj)
        #MultiJson.load(obj) here was mistake
      end
    else
      # @api private
      def self.json_load(obj)
        MultiJson.decode(obj)
      end
    end

  end
end

1
2018-04-25 13:04



Masalah dibahas sini

Untuk mengatasinya Anda juga dapat mencoba memperbarui multi_json gem seperti:

bundle update multi_json

Bagi saya memperbarui dari versi 1.0.3 ke 1.3.5 memecahkan masalah.


0
2018-05-23 23:20